
-- LuaHUB Discussion Forum - Trim unicode string
-- http://forum.luahub.com/index.php?topic=3522.0
-- I use a Chopup function by jpjacobs
-- ThankYou,jpjacobs!
function chopup(str)
  if type(str) ~= 'string'
  then return nil
  end
  local ret={}
  local pos = 1
  local b=string.byte
  local f=math.floor
  while pos <= #str do
    local first = b(str:sub(pos,pos))
    if first < 0x00000080 then -- ASCII
      ret[#ret+1]= str:sub(pos,pos)
      pos = pos+1
    elseif f(first/2^5) == 6 then -- 0b110 then -- Two byte UTF
      ret[#ret+1]= str:sub(pos,pos+1)
      pos = pos+2
    elseif f(first/2^4) == 14 then --0b1110 then -- Three byte UTF
      ret[#ret+1]= str:sub(pos,pos+2)
      pos = pos+3
    elseif f(first/2^3) == 46 then --0b11110 then -- Four byte UTF
      ret[#ret+1]= str:sub(pos,pos+3)
      pos = pos+4
    elseif f(first/2^2) == 110 then --0b111110 then -- Five byte UTF
      ret[#ret+1]= str:sub(pos,pos+4)
      pos = pos+5
    elseif f(first/2) == 238 then --0b1111110 then -- Six byte UTF
      ret[#ret+1]= str:sub(pos,pos+5)
      pos = pos+6
    else
      print("first byte faulty")
      pos=pos+1
    end
  end
  return ret
end

----------------------------------

-- using the chopup function ...

-- sub_utf ('͂悤',1,4) --> ͂悤
function sub_utf (str,x,...)
  if type(str) ~= 'string'
  then return nil
  end  
  local chp = chopup(str)
  local lngth = #chp
  local new = ""
  local y = select(1,...)
  if y == nil then
    y = lngth
  end
  if type(y) =='number' and y <0
  then y = lngth + y +1
  end
  if type(x) =='number' and x <0
  then x = lngth + x +1
  end
  if x >lngth or y >lngth then
    return nil
  end
  if type(x) =='number' and type(y) =='number'
    and x ~=0 and y ~=0    
    and x <= y
  then
    for i = x,y do
      new = new .. tostring(chp[i])
    end
  elseif type(x) =='number' and type(y) =='number'
    and x ~=0 and y ~=0
    and x > y
  then
    for i= x,y,-1 do
      new = new .. tostring(chp[i])
    end
  end
  return new
end


-- cut_utf("--","-")
--  --> 3   -
-- cut_utf("--","-",-1)
--  --> 6  -  
function cut_utf (str,separator,direction)
  if type(str) ~= 'string'
  then return nil
  end  
  local chp = chopup(str)
  local lngth = #chp
  local ini = 1
  if direction == -1 then
    ini = -1
  end
  local n
  if ini == 1
  then
    for i = 1,lngth do
      if chp[i] == separator then
        n = i
        break
      end
    end
  elseif ini == -1
  then
    for i = lngth,1,-1 do
      if chp[i] == separator then
        n = i
        break
      end
    end
  end
  if n == nil then return nil,str,nil
  else
  return n,sub_utf(str,1,n-1),sub_utf(str,n+1,lngth)
  end
end


